package data;

import java.rmi.*;
import java.sql.*;
import java.util.*;
import javax.ejb.*;
import javax.naming.*;
import javax.sql.*;

public abstract class ApplicantBean implements EntityBean
{
    // CMP fields
    public abstract String getLogin();
    public abstract void setLogin(String login);
    public abstract String getName();
    public abstract void setName(String name);
    public abstract String getEmail();
    public abstract void setEmail(String email);
    public abstract String getSummary();
    public abstract void setSummary(String summary);
    
    // CMR fields
    public abstract LocationLocal getLocation();
    public abstract void setLocation(LocationLocal location);
    public abstract Collection getSkills();
    public abstract void setSkills(Collection skills);


    // EJB methods start here

    public void ejbPostCreate (String login, String name, String email) {}

    public String ejbCreate (String login, String name, String email) throws CreateException 
    {
        try {
            ((ApplicantLocalHome)ctx.getEJBLocalHome()).findByPrimaryKey(login);
            throw new CreateException("Duplicate applicant name: "+name);
        }
        catch (FinderException ex) {}

        setLogin(login);
        setName(name);
        setEmail(email);
        setSummary("");

        return null;
    }

    public void ejbLoad(){}
    public void ejbStore(){}
    public void ejbPassivate(){}
    public void ejbActivate(){}
    public void ejbRemove(){}
    private EntityContext ctx;

    public void setEntityContext(EntityContext ctx) {
        this.ctx = ctx;
    }

    public void unsetEntityContext() {
        this.ctx = null;
    }

}
