package data;

import java.rmi.*;
import java.sql.*;
import java.util.*;
import javax.ejb.*;
import javax.naming.*;
import javax.sql.*;

public abstract class CustomerBean implements EntityBean
{
    // CMP fields
    public abstract String getLogin();
    public abstract void setLogin(String login);
    public abstract String getName();
    public abstract void setName(String name);
    public abstract String getEmail();
    public abstract void setEmail(String email);
    public abstract String getAddress1();
    public abstract void setAddress1(String address1);
    public abstract String getAddress2();
    public abstract void setAddress2(String address2);
    
    public void setAddress(String[] address){
        if (address.length > 1) {
            setAddress1(address[0]);
        }
        if (address.length > 2) {
            setAddress2(address[1]);
        }
    }

    public String[] getAddress() {
        return new String[]{getAddress1(),getAddress2()};
    }

    // EJB methods start here

    public void ejbPostCreate (String login, String name, String email) {}

    public String ejbCreate (String login, String name, String email) throws CreateException {
        try {
            ((CustomerLocalHome)ctx.getEJBLocalHome()).findByPrimaryKey(login);
            throw new CreateException("Duplicate customer name: "+name);
        }
        catch (FinderException ex) {}
        setLogin(login);
        setName(name);
        setEmail(email);
        setAddress1("");
        setAddress2("");
        return null;
    }

    public void ejbLoad() {}
    public void ejbStore() {}
    public void ejbPassivate() {}
    public void ejbActivate() {}
    public void ejbRemove() {}

    private EntityContext ctx;

    public void setEntityContext(EntityContext ctx) {
        this.ctx = ctx;
    }

    public void unsetEntityContext() {
        this.ctx = null;
    }

}
